#include "pch.h"
#include "XPlusDll.h"

/**
 * xFrame5 DLL Ʈ init API ȣ DLL ε ȣ
 * @param strComponentKey xFrame5 DLL Ʈ  Ű
 * @param hParent θ  ڵ(޽ ޽ )
 * @returns CXPlusDll Ŭ Ʈ( ߻ null)
 */
void* xplus_Init(LPCTSTR strComponentKey, HWND hParent)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	// CXPlusDll Ŭ Ʈ ϸ鼭 Ʈ Ű  θ  ڵ鰪 
	CXPlusDll* pXPlusDllComm = new CXPlusDll(strComponentKey, hParent);
	if (!pXPlusDllComm) {
		return NULL;
	}

	return pXPlusDllComm;
}

/**
 * xFrame5 DLL Ʈ invoke API ȣ ȣ
 * @param pXPlusDllComm CXPlusDll Ŭ Ʈ
 * @param strFuncName ȣ Լ ̸ ڿ
 * @param strParam ȣ Լ Ķ ڿ
 * @returns ó  ڿ Ǵ NULL
 */ 
LPCTSTR xplus_Invoke(void* pXPlusDllComm, LPCTSTR strFuncName, LPCTSTR strParam)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	
	if (!pXPlusDllComm) {
		return NULL;
	}
	
	// xFrame5 DLL Ʈ 񵿱 (sync_mode Ӽ false) , ϰ õ
	return ((CXPlusDll*)pXPlusDllComm)->Invoke(strFuncName, strParam);
}

////////////////////////////////////////////////////////////////////////////////
// CXPlusDll

/**
 * CXPlusDll  Լ. xplus_Init Լ ؼ ȣ
 * @param strComponentKey  ο ϴ DLL Ʈ Ű  ڿ
 * @param hParent θ  ڵ(޽ ޽ )
 */
CXPlusDll::CXPlusDll(LPCTSTR strComponentKey, HWND hParent)
{
	// Ķͷ ޵ Ʈ Ű  θ  ڵ  
	m_strComponentKey.Format(_T("%s"), strComponentKey);
	m_hParent = hParent;
}

/**
 * CXPlusDll Ҹ Լ
 */
CXPlusDll::~CXPlusDll()
{
}

/**
 * xFrame5 DLL Ʈ invoke API ȣ xplus_Invoke Լ ؼ ȣ
 * @param strFuncName ȣ Լ ̸ ڿ
 * @param strParam ȣ Լ Ķ ڿ
 * @returns ó  ڿ Ǵ NULL 
 * 			xFrame5 DLL Ʈ 񵿱 (sync_mode Ӽ false) , ϰ õ
 */ 
LPCTSTR CXPlusDll::Invoke(LPCTSTR strFuncName, LPCTSTR strParam)
{
	// xFrame5 DLL Ʈ  (sync_mode Ӽ true)  
	if (_tcsicmp(strFuncName, _T("syncmode_echo_func")) == 0) {
		// Do Something..

		// Լ ϰ xFrame5 DLL Ʈ invoke Լ ϰ ޵
		CString strResult;
		strResult.Format(_T("%s"), strParam);
		return strResult.GetBuffer(0);
	}	
	// xFrame5 DLL Ʈ 񵿱 (sync_mode Ӽ false)  
	else if (_tcsicmp(strFuncName, _T("asyncmode_echo_func")) == 0) {
		// Do Something..

		// ó  ͸ ϱ ؼ FireMessageEvent Լ ȣϿ 
		// xFrame5 DLL Ʈ on_message ̺Ʈ ߻Ѿ 
		FireMessageEvent(strFuncName, strParam);

		// Լ ϰ xFrame5 DLL Ʈ invoke Լ ϰ ޵ 
		return NULL;
	}	
	// xFrame5 DLL Ʈ on_message ̺Ʈ ߻Ű  
	else if (_tcsicmp(strFuncName, _T("fire_on_message")) == 0) {
		FireMessageEvent(strFuncName, strParam);
	}
	
	return NULL;
}

/**
 * DLL Ʈ on_message ̺Ʈ  
 * @param strMsgName on_message ̺Ʈ strMsgName ĶͿ ޵ ڿ
 * @param strData on_message ̺Ʈ strData ĶͿ ޵ ڿ
 * @returns  ó (true/false)
 */
BOOL CXPlusDll::FireMessageEvent(LPCTSTR strMsgName, LPCTSTR strData)
{
	// 1. ޽  ͹ڿ 
	CString strResult;
	strResult.Format(_T("%s"), strData);

	// 2. ޽  
	// typedef struct {
	//     wchar_t strComponentKey[64];	// Ʈ Ű
	//     wchar_t strMessage[64];		//  ޽ : on_message ̺Ʈ strMsgName
	//     long nDataLength;			//    : on_message ̺Ʈ strData 
	// } XdllMessageInfo;
	
	XdllMessageInfo XdllMsgInfo;
	memset(&XdllMsgInfo, 0x00, sizeof(XdllMessageInfo));

	// ƮŰ : m_strComponentKey ״ 
	wcscpy_s(XdllMsgInfo.strComponentKey, 64, m_strComponentKey.GetBuffer(0));

	//  ޽ : Invoke Լ  ޽  ڿ
	wcscpy_s(XdllMsgInfo.strMessage, 64, strMsgName);

	//   
	XdllMsgInfo.nDataLength = (long)strResult.GetLength();

	// 3. ޽ ͺ  
	long nDataTotalLen = sizeof(XdllMessageInfo) + XdllMsgInfo.nDataLength * sizeof(wchar_t);
	
	// 4. ޽ ޿ ޸    
	BYTE* pData = new BYTE[nDataTotalLen + 1];
	memset(pData, 0x00, nDataTotalLen + 1);
	memcpy(pData, (BYTE*)&XdllMsgInfo, sizeof(XdllMessageInfo));
	memcpy(pData + sizeof(XdllMessageInfo), strResult.GetBuffer(0), XdllMsgInfo.nDataLength * sizeof(wchar_t));

	// 5. WM_COPYDATA WM_XDLL_MESSAGE ޽ 
	COPYDATASTRUCT cds;
	cds.dwData = WM_XDLL_MESSAGE;
	cds.cbData = nDataTotalLen;
	cds.lpData = pData;
	
	// θ  ڵ鰪 
	if (::IsWindow(m_hParent)) {
		::SendMessage(m_hParent, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cds);
	}
	
	// ޽ ޿ ޸ 
	if (pData) { delete pData; }
	
	return true;
}